    PROGRAM nag_lin_lsq_ex11

      ! Example Program Text for nag_lin_lsq
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_lin_lsq, ONLY : nag_qr_fac, nag_lin_lsq_sol_qr, &
       nag_lin_lsq_sol_qr_svd
      USE nag_write_mat, ONLY : nag_write_gen_mat
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND, MIN
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, m, n, nrhs, ns
      ! .. Local Arrays ..
      INTEGER, ALLOCATABLE :: pivot(:)
      REAL (wp), ALLOCATABLE :: a(:,:), b(:,:), b_cpy(:,:), std_err_b(:), &
       std_err_ls(:), tau(:), x_b(:,:), x_ls(:,:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_lin_lsq_ex11'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) m, n, nrhs
      ns = MIN(m,n)

      ALLOCATE (pivot(n),a(m,n),b(m,nrhs),b_cpy(m,nrhs),tau(ns), &
       std_err_b(nrhs),x_b(n,nrhs),std_err_ls(nrhs), &
       x_ls(n,nrhs))               ! Allocate storage

      READ (nag_std_in,*) (a(i,:),i=1,m)
      READ (nag_std_in,*) (b(i,:),i=1,m)
      b_cpy = b

      ! Compute the QR factorization
      pivot = 0

      CALL nag_qr_fac(a,tau,pivot=pivot)

      ! Compute the basic solution

      CALL nag_lin_lsq_sol_qr(a,tau,b,x_b,pivot=pivot,std_err=std_err_b)

      WRITE (nag_std_out,*)

      CALL nag_write_gen_mat(x_b,int_col_labels=.TRUE.,format='(F8.4)', &
       title='Basic solutions (one solution per column)')

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) ' Standard errors'
      WRITE (nag_std_out,'(2X,4(F8.4:,1X))') std_err_b
      WRITE (nag_std_out,*)

      ! Compute the minimum norm solution

      b = b_cpy

      CALL nag_lin_lsq_sol_qr_svd(a,tau,b,x_ls,pivot=pivot,std_err=std_err_ls)

      WRITE (nag_std_out,*)

      CALL nag_write_gen_mat(x_ls,int_col_labels=.TRUE.,format='(F8.4)', &
       title='Minimum norm solutions (one solution per column)')

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) ' Standard errors'
      WRITE (nag_std_out,'(2X,4(F8.4:,1X))') std_err_ls
      WRITE (nag_std_out,*)

      DEALLOCATE (pivot,a,b,b_cpy,tau,std_err_b,std_err_ls,x_b, &
       x_ls)                       ! Deallocate storage

    END PROGRAM nag_lin_lsq_ex11
